      SUBROUTINE MUTEAP(IADDR,JADDR,N,NEXT,NSAMPS)
C   MUTEAP IS A VFC (VECTOR FUNCTION CHAINER) ROUTINE TO PERFORM MUTING ON A
C  TRACE THAT IS IN THE AP.  MUTEAP WILL DO FRONT END MUTING OR SURGICAL MUTING.
C  A MUTE TAPER IS APPLIED WHEN APPROPRIATE.  THE INVERSE OF N (1./N) MUST BE
C  IN AP LOCATION NEXT.  THE FIRST SAMPLE OF THE TRAC IS ASSUMED TO BE IN AP
C  LOCATION 1.
C
C  ARGUMENTS:
C  IADDR  - THE AP ADDRESS OF THE START OF THE MUTE ZONE.  IADDR=1 INDICATES
C           THAT THE MUTE IS A FRONT END MUTE (NO TAPER APPLIED ON THE FRONT).
C  JADDR  - THE AP ADDRESS OF THE END OF THE MUTE ZONE.
C  N      - THE NUMBER OF SAMPLES OF THE MUTE TAPER. (1./N MUST BE IN NEXT)
C  NEXT   - THE AP ADDRESS OF THE INVERSE OF N.
C  NSAMPS - THE TOTAL NUMBER OF SAMPLES IN THE TRACE.  THE AP ADDRESS OF THE
C         LAST SAMPLE OF THE TRACE.
C
C  PAUL HENKART, SCRIPPS INSTITUTION OF OCEANOGRAPHY, APRIL 1980
C
C      LOCAL NZEROS,IADR,JADR,NEXTAD,N1
      NZEROS=JADDR-IADDR
      NZEROS=NZEROS+1
      IADR=IADDR
      JADR=JADDR
       IF( N.LE.0) GOTO 200
      N1=N-1
      CALL VRAMP(NEXT,NEXT,NEXT,1,N1)
      NEXTAD=NEXT+N1
      NEXTAD=NEXTAD-1
      IF( IADR.EQ.1) GOTO 100
      CALL VMUL(IADR,1,NEXTAD,-1,IADR,1,N1)
      IADR=IADR+N1
      NZEROS=NZEROS-N1
100   IF( JADR.EQ.NSAMPS) GOTO 200
      CALL VMUL(JADR,-1,NEXTAD,-1,JADR,-1,N1)
      NZEROS=NZEROS-N1
200   CALL VCLR(IADR,1,NZEROS)
      RETURN
      END
